%global momorel 4

%global emacsver 23.0.95
%global xemacsver 21.5.29
%global xemacssumover 2009.02.17
%global e_sitedir %{_datadir}/emacs/site-lisp
%global emacs_startdir %{_datadir}/emacs/site-lisp/site-start.d
#%%global xe_sitedir %{_datadir}/xemacs/site-lisp
%global sitepdir %{_datadir}/xemacs/site-packages

%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Summary: A fast, lightweight distributed source control management system 
Name: mercurial
Version: 1.2.1
Release: %{momorel}m%{?dist}
License: GPLv2
Group: Development/Tools
URL: http://www.selenic.com/mercurial/
Source0: http://www.selenic.com/mercurial/release/%{name}-%{version}.tar.gz
NoSource: 0
Source1: mercurial-site-start.el
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: emacs >= %{emacsver}
BuildRequires: xemacs >= %{xemacsver}
BuildRequires: xemacs-sumo >= %{xemacssumover}
BuildRequires: python-devel
BuildRequires: pkgconfig
Requires: python
Requires: zsh
#%%dir %{_datadir}/zsh/site-functions/
Requires: bash-completion
#%%dir %{_sysconfdir}/bash_completion.d/

Provides: hg = %{version}-%{release}


%description
Mercurial is a fast, lightweight source control management system designed
for efficient handling of very large distributed projects.

Quick start: http://www.selenic.com/mercurial/wiki/index.cgi/QuickStart
Tutorial: http://www.selenic.com/mercurial/wiki/index.cgi/Tutorial
Extensions: http://www.selenic.com/mercurial/wiki/index.cgi/CategoryExtension

%package emacs
Group: Development/Tools
Summary: Emacs support for the Mercurial distributed SCM
Requires: mercurial = %{version}-%{release}
Requires: emacs >= %{emacsver}

%description emacs
Emacs support for the Mercurial distributed SCM.

%package xemacs
Group: Development/Tools
Summary: XEmacs support for the Mercurial distributed SCM
Requires: mercurial = %{version}-%{release}
Requires: xemacs >= %{xemacsver}

%description xemacs
XEmacs support for the Mercurial distributed SCM.


%package hgk
Summary:	Hgk interface for mercurial
Group:		Development/Tools
Requires:	hg = %{version}-%{release}, tk

%description hgk
A Mercurial extension for displaying the change history graphically
using Tcl/Tk.  Displays branches and merges in an easily
understandable way and shows diffs for each revision.  Based on
gitk for the git SCM.

Adds the "hg view" command.  See 
http://www.selenic.com/mercurial/wiki/index.cgi/UsingHgk for more
documentation.


%prep
%setup -q

%build
make all

%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --root $RPM_BUILD_ROOT --prefix %{_prefix} --record=%{name}.files
make install-doc DESTDIR=$RPM_BUILD_ROOT MANDIR=%{_mandir}

grep -v 'hgk.py*' < %{name}.files > %{name}-base.files
grep 'hgk.py*' < %{name}.files > %{name}-hgk.files

install -D contrib/hgk       $RPM_BUILD_ROOT%{_libexecdir}/mercurial/hgk
install contrib/convert-repo $RPM_BUILD_ROOT%{_bindir}/mercurial-convert-repo
install contrib/hg-ssh       $RPM_BUILD_ROOT%{_bindir}
install contrib/git-viz/{hg-viz,git-rev-tree} $RPM_BUILD_ROOT%{_bindir}

bash_completion_dir=$RPM_BUILD_ROOT%{_sysconfdir}/bash_completion.d
mkdir -p $bash_completion_dir
install -m 644 contrib/bash_completion $bash_completion_dir/mercurial.sh

zsh_completion_dir=$RPM_BUILD_ROOT%{_datadir}/zsh/site-functions
mkdir -p $zsh_completion_dir
install -m 644 contrib/zsh_completion $zsh_completion_dir/_mercurial

%__mkdir_p %{buildroot}%{_mandir}/man1
%__mkdir_p %{buildroot}%{_mandir}/man5
%__install -m 0644 doc/hg.1 %{buildroot}%{_mandir}/man1/hg.1
%__install -m 0644 doc/hgrc.5 %{buildroot}%{_mandir}/man5/hgrc.5
%__install -m 0644 doc/hgignore.5 %{buildroot}%{_mandir}/man5/hgignore.5

pushd contrib
# emacs
emacs -q -no-site-file -batch -f batch-byte-compile %{name}.el
%__mkdir_p %{buildroot}%{e_sitedir}
%__install -m 0644 %{name}.el %{buildroot}%{e_sitedir}/%{name}.el
%__install -m 0644 %{name}.elc %{buildroot}%{e_sitedir}/%{name}.elc
%__rm %{name}.elc
# xemacs
xemacs -q -no-site-file -batch -f batch-byte-compile %{name}.el
%__mkdir_p %{buildroot}%{sitepdir}/lisp
%__install -m 0644 %{name}.el %{buildroot}%{sitepdir}/lisp/%{name}.el
%__install -m 0644 %{name}.elc %{buildroot}%{sitepdir}/lisp/%{name}.elc
%__rm %{name}.elc
popd


mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/mercurial/hgrc.d

mkdir -p $RPM_BUILD_ROOT/%{emacs_startdir} && install -m644 %SOURCE1 $RPM_BUILD_ROOT/%{emacs_startdir}

cat >hgk.rc <<EOF
[extensions]
# enable hgk extension ('hg help' shows 'view' as a command)
hgk=

[hgk]
path=%{_libexecdir}/mercurial/hgk
EOF
install hgk.rc $RPM_BUILD_ROOT/%{_sysconfdir}/mercurial/hgrc.d

install contrib/mergetools.hgrc $RPM_BUILD_ROOT%{_sysconfdir}/mercurial/hgrc.d/mergetools.rc

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files -f %{name}.files
%defattr(-, root, root)
%doc CONTRIBUTORS COPYING doc/README doc/hg*.txt doc/hg*.html doc/ja *.cgi contrib/*.fcgi
%doc %attr(644,root,root) %{_mandir}/man?/hg*.*
%doc %attr(644,root,root) contrib/*.svg contrib/sample.hgrc
%{_sysconfdir}/bash_completion.d/mercurial.sh
%{_datadir}/zsh/site-functions/_mercurial
%{_bindir}/hg-ssh
%{_bindir}/hg-viz
%{_bindir}/git-rev-tree
%{_bindir}/mercurial-convert-repo
%dir %{_sysconfdir}/mercurial
%dir %{_sysconfdir}/mercurial/hgrc.d
%config(noreplace) %{_sysconfdir}/mercurial/hgrc.d/mergetools.rc
%dir %{python_sitearch}/mercurial
%dir %{python_sitearch}/hgext
%exclude %{python_sitearch}/hgext/hgk.py*

%files -n mercurial-emacs
%defattr(-, root, root)
%{e_sitedir}/%{name}.el*
%{emacs_startdir}/*.el

%files -n mercurial-xemacs
%defattr(-, root, root)
%{sitepdir}/lisp/%{name}.el*

%files hgk -f %{name}-hgk.files
%{_libexecdir}/mercurial/
%{_sysconfdir}/mercurial/hgrc.d/hgk.rc

%changelog
* Sun Jun 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.2.1-4m)
- rebuild against emacs-23.0.95

* Mon May 25 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.2.1-3m)
- rebuild against emacs-23.0.94

* Fri May 22 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.2.1-2m)
- rebuild against xemacs-21.5.29

* Fri May  1 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.2.1-1m)
- update

* Thu Apr  2 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.2-3m)
- rebuild against emacs-23.0.92

* Tue Mar 10 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.2-2m)
- fix about %%{emacs_startdir}

* Sat Mar  7 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.2-1m)
- update to 1.2

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.1.2-4m)
- rebuild against rpm-4.6

* Thu Jan 15 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.1.2-1m)
- update to 1.1.2

* Thu Jan  1 2009 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (1.0.2-3m)
- rebuild against python-2.6.1-1m

* Mon Oct 27 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0.2-2m)
- add BuildRequires: python-devel for use Python.h

* Wed Sep  3 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.0.2-1m)
- [SECURITY] CVE-2008-4297
- update to 1.0.2

* Thu Jul 24 2008 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0.1-2m)
- rebuild against xemacs-21.5.28
- use %%{sitepdir}

* Tue Jun 24 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0.1-1m)
- update to 1.0.1

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0-2m)
- rebuild against gcc43
 
* Tue Mar 25 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0-1m)
- update to 1.0

* Fri Nov  9 2007 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.9.5-1m)
- update to 0.9.5

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.9.3-2m)
- rebuild against python-2.5

* Wed Dec 20 2006 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.3-1m)
- update to 0.9.3

* Mon Nov 13 2006 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.1-3m)
- revise %%prep, %%build, %%install sections
  referred to Fedora Extras devel
- create mercurial-emacs and mercurial-xemacs  

* Tue Nov  7 2006 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.1-2m)
- add man pages

* Thu Sep 28 2006 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.9.1-1m)
- update to 0.9.1

* Wed Jun  7 2006 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.9-2m)
- fix files list conflicts (nigirisugi)

* Mon May 22 2006 NARITA Koichi <pulsar@sea.plala.or.jp>
- (0.9-1m)
- update to 0.9

* Thu Apr  6 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.7-2m)
- revised doc owner

* Wed Jan 11 2006 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.7-1m)
- import to Momonga
